set global log_bin_trust_function_creators = 1;
----
DROP FUNCTION IF EXISTS zn_plugin_stock_convert_product;
CREATE FUNCTION zn_plugin_stock_convert_product($id int(11))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select concat(zn_title, '(', model, ')') INTO _temp from zn_plugin_stock_product where id=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_stock_convert_product_sn;
CREATE FUNCTION zn_plugin_stock_convert_product_sn($id varchar(100))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select concat(zn_title, '(', model, ')') INTO _temp from zn_plugin_stock_product where serial_number=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_stock_convert_product_model;
CREATE FUNCTION zn_plugin_stock_convert_product_model($id varchar(100))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select concat(zn_title, ' (', model, ')') INTO _temp from zn_plugin_stock_product where model=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_stock_convert_product_id;
CREATE FUNCTION zn_plugin_stock_convert_product_id($id varchar(100))
RETURNS int(11)
BEGIN
DECLARE _temp int(11);
select id INTO _temp from zn_plugin_stock_product where serial_number=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_stock_convert_warehouse;
CREATE FUNCTION zn_plugin_stock_convert_warehouse($id int(11))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select concat(zn_title, '(', city, ')') INTO _temp from zn_plugin_stock_warehouse where id=$id;
RETURN _temp;
END
