zn.define(function () {

    var model = zn.db.common.model;

    return zn.Model("zn_plugin_stock_product", {
        mixins: [
            model.Base
        ],
        properties: {
            serial_number: {
                value: null, //商品序号
                type: ['varchar', 100],
                default: ''
            },
            model: {
                value: null, //型号
                type: ['varchar', 100],
                default: ''
            },
            specification: {
                value: null, //规格
                type: ['varchar', 100],
                default: ''
            },
            status: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            type_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            net_weight: {  //净重
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            gross_weight: {  //毛重
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            package_size: {  //包装尺寸
                value: null,
                type: ['varchar', 100],
                default: ''
            },
            volume: {  //容积
                value: null,
                type: ['varchar', 100],
                default: ''
            },
            price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            min_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            average_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            max_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            purchase_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            sale_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            express_price: {
                value: null,
                type: ['decimal', [10, 2]],
                default: 0
            },
            icon: {
                value: null,
                type: ['varchar', 20],
                default: ''
            },
            unit: {
                value: null,
                type: ['varchar', 10],
                default: '台'
            },
            tags: {
                value: null,
                type: ['varchar', 500],
                default: ','
            },
            logo: {
                value: null,
                type: ['varchar', 500],
                default: ''
            },
            images: {
                value: null,
                type: ['varchar', 5000],
                default: ','
            },
            videos: {
                value: null,
                type: ['varchar', 5000],
                default: ','
            },
            details: {
                value: null,
                type: ['LONGTEXT']
            },
            files: {
                value: null,
                type: ['varchar', 5000],
                default: ','
            }
        }
    });

})
