"use strict";

require('./BatchProductList.less');

var React = require('react');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    var _where = {};

    if (this.props.batchId) {
      _where.batch_id = this.props.batchId;
    }

    if (this.props.warehouseId) {
      _where.warehouse_id = this.props.warehouseId;
    }

    if (this.props.productModel) {
      _where.product_model = this.props.productModel;
    }

    return {
      data: zn.store.post('/zn.plugin.admin/model/select', {
        model: 'zn_plugin_stock_product_batch_detail',
        where: _where
      }),
      values: [],
      items: [//{ title: '批次号', name: 'batch_code', width: 160 },
      {
        title: '商品名称',
        name: 'product_model_convert',
        width: 280
      }, {
        title: '总量',
        name: 'number',
        width: 80
      }, {
        title: '库存量',
        name: 'unused_number',
        width: 80
      }, {
        title: '已用量',
        name: 'used_number',
        width: 80
      }, {
        title: '批次价(￥)',
        name: 'price',
        width: 120
      }, {
        title: '总金额(￥)',
        name: 'amount',
        width: 120
      }, {
        title: '创建时间',
        name: 'zn_create_time',
        width: 150
      }, {
        title: '创建人',
        name: 'zn_create_user_convert',
        width: 130
      }, {
        title: '说明',
        name: 'zn_note'
      }]
    };
  },
  componentDidMount: function componentDidMount() {
    this.state.data.exec().then(function (data) {
      this.setState({
        values: data.result
      });
    }.bind(this));
  },
  __onTableColumnRender: function __onTableColumnRender(data, item, value) {
    if (item.title && item.title.indexOf('￥') != -1) {
      value = value.toFixed(2) + '￥';
    }

    switch (item.name) {
      case 'unused_number':
        return React.createElement("span", {
          style: {
            color: 'green',
            fontWeight: 600
          }
        }, value);

      case 'used_number':
        return React.createElement("span", {
          style: {
            color: 'red',
            fontWeight: 600
          }
        }, value);
    }

    return value;
  },
  render: function render() {
    return React.createElement("div", {
      className: "zn-plugin-stock-batch-product-list"
    }, React.createElement("table", {
      className: "zr-table"
    }, React.createElement("colgroup", {
      className: "data-header"
    }, this.state.items.map(function (item, index) {
      return React.createElement("col", {
        style: {
          width: item.width
        }
      });
    })), React.createElement("thead", null, React.createElement("tr", {
      className: "table-row thead"
    }, this.state.items.map(function (item, index) {
      return React.createElement("th", {
        className: "text-align-left"
      }, item.title);
    }))), React.createElement("thead", null, this.state.values.map(function (data, index) {
      return React.createElement("tr", {
        key: index,
        className: "table-row",
        style: {
          backgroundColor: '#FFF'
        }
      }, this.state.items.map(function (item, index) {
        return React.createElement("td", {
          className: "text-align-left"
        }, this.__onTableColumnRender(data, item, data[item.name]));
      }.bind(this)));
    }.bind(this)))));
  }
});