"use strict";

var React = require('react');

module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      model: 'ZNPluginStockProduct'
    };
  },
  getInitialState: function getInitialState() {
    return {
      data: zn.store.post('/zn.plugin.admin/model/paging', {
        model: this.props.model,
        where: this.props.productType ? {
          type_id: this.props.productType
        } : null
      }),
      items: [//{ title: '序列号', name: 'serial_number', width: 130, filter: { type: 'Input', opts: ['like'] }  },
      {
        title: '商品名称',
        name: 'zn_title',
        width: 160,
        filter: {
          type: 'Input',
          opts: ['like']
        }
      }, {
        title: '型号',
        name: 'model',
        width: 160,
        filter: {
          type: 'Input',
          opts: ['like']
        }
      }, {
        title: '规格',
        name: 'specification',
        width: 60
      }, {
        title: '单位',
        name: 'unit',
        width: 60
      }, {
        title: '净重(Kg)',
        name: 'net_weight',
        width: 100
      }, {
        title: '毛重(Kg)',
        name: 'gross_weight',
        width: 100
      }, {
        title: '包装尺寸(mm)',
        name: 'package_size',
        width: 100
      }, {
        title: '容积(L)',
        name: 'volume',
        width: 100
      }, {
        title: '单价(￥)',
        name: 'price',
        width: 100
      }, {
        title: '最低价(￥)',
        name: 'min_price',
        width: 100
      }, {
        title: '平均价(￥)',
        name: 'average_price',
        width: 100
      }, {
        title: '最高价(￥)',
        name: 'max_price',
        width: 100
      }, {
        title: '采购价(￥)',
        name: 'purchase_price',
        width: 100
      }, {
        title: '销售价(￥)',
        name: 'sale_price',
        width: 100
      }, {
        title: '物流单价(￥)',
        name: 'express_price',
        width: 100
      }, {
        title: '说明',
        name: 'zn_note'
      }],
      formItems: [{
        title: 'LOGO',
        name: 'LOGO',
        type: 'ImageUploader',
        action: '/zn.plugin.admin/uploadFiles'
      }, {
        title: '商品名称',
        name: 'zn_title',
        type: 'Textarea',
        required: true,
        error: '商品名称必填项!'
      }, {
        title: '状态',
        name: 'status',
        type: 'Select',
        data: [{
          text: '上架',
          value: 1
        }, {
          text: '下架',
          value: 0
        }]
      }, //{ title: '序列号', name: 'serial_number', type: 'Input', value: 'xxxx' },
      {
        title: '型号',
        name: 'model',
        type: 'Input'
      }, {
        title: '规格',
        name: 'specification',
        type: 'Input'
      }, {
        title: '单位',
        name: 'unit',
        type: 'Input',
        placeholder: '个/套/件/品/瓶'
      }, {
        title: '图片',
        name: 'images',
        type: 'FileUploader',
        action: '/zn.plugin.admin/uploadFiles'
      }, {
        title: '视频',
        name: 'videos',
        type: 'FileUploader',
        action: '/zn.plugin.admin/uploadFiles'
      }, {
        title: '附件',
        name: 'files',
        type: 'FileUploader',
        action: '/zn.plugin.admin/uploadFiles'
      }, {
        title: '单价',
        name: 'price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '最低价',
        name: 'min_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '平均价',
        name: 'average_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '最高价',
        name: 'max_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '采购价',
        name: 'purchase_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '销售价',
        name: 'sale_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '物流单价',
        name: 'express_price',
        type: 'Input',
        attrs: {
          type: 'number',
          step: 0.01
        },
        suffix: '￥'
      }, {
        title: '描述',
        name: 'details',
        type: 'RichEditor'
      }, {
        title: '说明',
        name: 'zn_note',
        type: 'Textarea'
      }],
      toolbarItems: [{
        text: '添加',
        method: '__addItem',
        icon: 'fa-plus',
        style: {
          marginRight: 5
        }
      }, {
        text: '删除',
        method: '__removeItems',
        status: 'danger',
        icon: 'fa-remove',
        style: {
          marginRight: 5
        }
      }]
    };
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.refresh) {
      this.state.data.refresh();
    } else if (nextProps.productType) {
      this.state.data.extend({
        where: {
          type_id: nextProps.productType
        }
      }).refresh();
    }
  },
  __doSuccess: function __doSuccess() {
    this.state.data.refresh();
  },
  __addItem: function __addItem() {
    if (!this.props.productType) {
      return zn.notification.error('请先从左边栏选择商品类型!'), false;
    }

    zn.dialog({
      title: '新增',
      content: React.createElement(zn.react.Form, {
        action: "/zn.plugin.admin/model/insert",
        merge: "values",
        hiddens: {
          type_id: this.props.productType,
          serial_number: 'SN' + zn.util.randomNumbers(10)
        },
        exts: {
          model: this.props.model
        },
        onSubmitSuccess: this.__doSuccess,
        items: this.state.formItems
      })
    });
  },
  __updateItem: function __updateItem(data) {
    zn.dialog({
      title: '更新',
      content: React.createElement(zn.react.Form, {
        merge: "updates",
        action: "/zn.plugin.admin/model/update",
        exts: {
          model: this.props.model,
          where: {
            id: data.id
          }
        },
        value: zn.store.post("/zn.plugin.admin/model/selectOne", {
          model: this.props.model,
          where: {
            id: data.id
          }
        }),
        onSubmitSuccess: this.__doSuccess,
        items: this.state.formItems
      })
    });
  },
  __removeItems: function __removeItems() {
    var _self = this,
        _values = this.refs.table.getValue();

    if (_values && _values.length) {
      zn.confirm('确认删除这' + _values.length + '个数据吗？', '提示', function () {
        zn.http.post('/zn.plugin.admin/model/delete', {
          model: this.props.model,
          where: "id in (" + _values.join(',') + ")"
        }).then(function (data) {
          if (data.status == 200) {
            zn.notification.success('删除成功');

            _self.state.data.refresh();
          } else {
            zn.notification.error('调用失败: ' + data.result);
          }
        }, function () {
          zn.notification.error('服务器错误: 删除失败');
        });
      }.bind(this));
    } else {
      zn.notification.warning('请先选择要删除的数据');
    }
  },
  __onToolbarClick: function __onToolbarClick(item) {
    this[item.method] && this[item.method]();
  },
  __onTableColumnRender: function __onTableColumnRender(rowIndex, columnIndex, data, item, value) {
    var _this = this;

    if (item.name == 'model') {
      return React.createElement("div", null, React.createElement("i", {
        "data-tooltip": "\u590D\u5236\u5E8F\u5217\u53F7",
        onClick: function onClick() {
          return zn.react.copyToClipboard(value);
        },
        className: "fa fa-clipboard"
      }), " ", React.createElement("a", {
        onClick: function onClick() {
          return _this.__updateItem(data);
        }
      }, React.createElement("i", {
        className: "fa fa-edit zr-padding-3"
      }), value));
    }

    if (item.title && item.title.indexOf('￥') != -1) {
      value = value.toFixed(2) + '￥';
    }

    return value;
  },
  render: function render() {
    return React.createElement(zn.react.PagerView, {
      ref: "table",
      view: "Table",
      enableFilter: true,
      checkbox: 50,
      showHeader: true,
      toolbarItems: this.state.toolbarItems,
      onToolbarClick: this.__onToolbarClick,
      columnRender: this.__onTableColumnRender,
      data: this.state.data,
      dataFixed: true,
      items: this.state.items
    });
  }
});