"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var React = require('react');

module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      eventType: 'click',
      model: 'ZNPluginStockProduct'
    };
  },
  getInitialState: function getInitialState() {
    return {
      value: this.props.value || '',
      text: this.props.text || '',
      data: zn.store.post('/zn.plugin.admin/model/paging', {
        model: this.props.model,
        where: this.props.productType ? {
          type_id: this.props.productType
        } : null
      }),
      items: [//{ title: '序列号', name: 'serial_number', width: 110, filter: { type: 'Input', opts: ['like'] }  },
      {
        title: '商品名称',
        name: 'zn_title',
        width: 160,
        filter: {
          type: 'Input',
          opts: ['like']
        }
      }, {
        title: '型号',
        name: 'model',
        width: 100,
        filter: {
          type: 'Input',
          opts: ['like']
        }
      }, {
        title: '规格',
        name: 'specification',
        width: 60
      }, {
        title: '单位',
        name: 'unit',
        width: 60
      }, {
        title: '净重(Kg)',
        name: 'net_weight',
        width: 100
      }, {
        title: '毛重(Kg)',
        name: 'gross_weight',
        width: 100
      }, {
        title: '包装尺寸(mm)',
        name: 'package_size',
        width: 100
      }, {
        title: '容积(L)',
        name: 'volume',
        width: 100
      }, {
        title: '单价(￥)',
        name: 'price',
        width: 100
      }, {
        title: '最低价(￥)',
        name: 'min_price',
        width: 100
      }, {
        title: '平均价(￥)',
        name: 'average_price',
        width: 100
      }, {
        title: '最高价(￥)',
        name: 'max_price',
        width: 100
      }, {
        title: '采购价(￥)',
        name: 'purchase_price',
        width: 100
      }, {
        title: '销售价(￥)',
        name: 'sale_price',
        width: 100
      }, {
        title: '物流单价(￥)',
        name: 'express_price',
        width: 100
      }]
    };
  },
  getValue: function getValue() {
    return this.state.value;
  },
  setValue: function setValue(value, text) {
    this.setState({
      value: value,
      text: text
    }, function () {
      this.props.onChange && this.props.onChange(value, this, null);
    });
  },
  __textRender: function __textRender() {
    return this.state.text || this.props.placeholder;
  },
  __onSelectorChange: function __onSelectorChange(value) {
    //this.setValue(value, item[rtlist.props.textKey]);
    zn.popover.close('DropdownSelector:selector.onchange');
  },
  __onTableColumnRender: function __onTableColumnRender(rowIndex, columnIndex, data, item, value) {
    if (item.title && item.title.indexOf('￥') != -1) {
      value = value.toFixed(2) + '￥';
    }

    return value;
  },
  __onPopoverClick: function __onPopoverClick(event) {
    event.stopPropagation();
  },
  __onTableRowClick: function __onTableRowClick(event, obj, row) {
    var _data = row.props.data;
    this.setValue(_data.id, _data.zn_title + "【" + _data.model + ' / ' + _data.specification + "】");
    zn.popover.close();
  },
  __popoverRender: function __popoverRender() {
    return React.createElement("div", {
      onClick: this.__onPopoverClick
    }, React.createElement(zn.react.PagerView, {
      view: "Table",
      enableFilter: true,
      showHeader: true,
      columnRender: this.__onTableColumnRender,
      onTableRowClick: this.__onTableRowClick,
      data: this.state.data,
      dataFixed: false,
      items: this.state.items
    }));
  },
  render: function render() {
    return React.createElement(zn.react.Dropdown, _extends({}, this.props, {
      popoverRender: this.__popoverRender,
      className: "zr-dropdown-selector",
      style: {
        width: '100%',
        maxHeight: 200
      },
      popoverWidth: 480
    }), React.createElement("div", {
      className: "zr-dropdown-selector-text-view"
    }, React.createElement("span", {
      className: "text"
    }, this.__textRender()), React.createElement("i", {
      className: "trigger fa fa-angle-down"
    })));
  }
});