"use strict";

require('./ProductSelector.less');

var React = require('react');

var Product = React.createClass({
  displayName: "Product",
  getInitialState: function getInitialState() {
    return {
      active: false
    };
  },
  render: function render() {
    var _this = this;

    var item = this.props.data;
    return React.createElement("li", {
      className: "product"
    }, React.createElement("div", {
      className: "title"
    }, React.createElement("span", null, React.createElement("i", {
      style: {
        width: 16,
        textAlign: 'center',
        cursor: 'pointer'
      },
      onClick: function onClick() {
        return _this.setState({
          active: !_this.state.active
        });
      },
      className: "fa zr-padding-3 " + (this.state.active ? 'fa-angle-down' : 'fa-angle-right')
    }), item.zn_title + " " + item.model), React.createElement("span", {
      onClick: function onClick() {
        return _this.props.onSelect(item);
      },
      className: "zr-tag zr-fr"
    }, React.createElement("i", {
      className: "fa fa-mouse-pointer zr-padding-3"
    }), "\u9009\u62E9\u5546\u54C1")), React.createElement("div", {
      className: "details",
      style: {
        display: this.state.active ? 'block' : 'none'
      }
    }, React.createElement("div", {
      className: "group"
    }, React.createElement("div", null, "\u5305\u88C5\u5C3A\u5BF8\uFF1A ", item.package_size), React.createElement("div", null, "\u51C0\u91CD\uFF1A ", item.net_weight, "/KG")), React.createElement("div", {
      className: "group"
    }, React.createElement("div", null, "\u5546\u54C1\u4EF7\uFF1A \uFFE5", item.price.toFixed(2)), React.createElement("div", null, "\u5E73\u5747\u4EF7\uFF1A \uFFE5", item.average_price.toFixed(2)), React.createElement("div", null, "\u91C7\u8D2D\u4EF7\uFF1A \uFFE5", item.purchase_price.toFixed(2)), React.createElement("div", null, "\u9500\u552E\u4EF7\uFF1A \uFFE5", item.sale_price.toFixed(2)), React.createElement("div", null, "\u7269\u6D41\u4EF7\uFF1A \uFFE5", item.express_price.toFixed(2)))));
  }
});
var ProductSearcher = React.createClass({
  displayName: "ProductSearcher",
  getInitialState: function getInitialState() {
    return {
      data: [],
      sources: []
    };
  },
  componentDidMount: function componentDidMount() {
    this.__loadProducts();
  },
  __loadProducts: function __loadProducts() {
    zn.http.post('/zn.plugin.admin/model/select', {
      model: "ZNPluginStockProduct"
    }).then(function (data) {
      if (data.status == 200) {
        this.setState({
          data: data.result,
          sources: data.result
        });
      } else {
        zn.notification.error(data.result);
      }
    }.bind(this), function () {
      zn.notification.error('请求失败');
    });
  },
  __onPopoverClick: function __onPopoverClick(event) {
    event.stopPropagation();
  },
  searchAll: function searchAll(name) {
    this.state.data = this.state.sources.slice(0).filter(function (item, index) {
      if (item.model.toLocaleLowerCase().indexOf(name.toLocaleLowerCase()) != -1 || item.zn_title.toLocaleLowerCase().indexOf(name.toLocaleLowerCase()) != -1) {
        return true;
      }
    });
    this.forceUpdate();
  },
  __onSearchKeyUp: function __onSearchKeyUp(event) {
    var _event = event.nativeEvent;

    if (_event.keyCode == 13) {
      var _value = _event.target.value;
      this.searchAll(_value);
    }
  },
  __onSearchChange: function __onSearchChange(event) {
    var _event = event.nativeEvent;

    if (!_event.target.value) {
      this.searchAll('');
    }
  },
  onProductSelect: function onProductSelect(item) {
    this.props.onChange(item);
  },
  __renderData: function __renderData() {
    if (this.state.data && this.state.data.length) {
      return React.createElement("ul", {
        className: "content products"
      }, this.state.data.map(function (item) {
        var _this2 = this;

        return React.createElement(Product, {
          data: item,
          onSelect: function onSelect() {
            return _this2.onProductSelect(item);
          }
        });
      }.bind(this)));
    } else {
      return React.createElement(zn.react.DataLoader, {
        loader: "timer",
        content: "\u6B63\u5728\u52A0\u8F7D\u4E2D..."
      });
    }
  },
  render: function render() {
    var _this3 = this;

    return React.createElement("div", {
      className: "zn-plugin-stock-product-searcher",
      onClick: this.__onPopoverClick
    }, React.createElement("div", {
      className: "header"
    }, React.createElement("span", null, "[ ", this.state.data.length, "\u4E2A ] \u5546\u54C1"), React.createElement("div", {
      className: "zn-plugin-stock-searcher"
    }, React.createElement("input", {
      placeholder: "\u6839\u636E\u578B\u53F7\u67E5\u8BE2",
      onChange: function onChange(event) {
        return _this3.__onSearchChange(event);
      },
      onKeyUp: function onKeyUp(event) {
        return _this3.__onSearchKeyUp(event);
      },
      className: "search-input",
      type: "search",
      name: "search"
    }), React.createElement("i", {
      className: "fa fa-search"
    }))), this.__renderData());
  }
});
module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      eventType: 'click'
    };
  },
  getInitialState: function getInitialState() {
    return {
      value: this.props.value || '',
      text: this.props.text || ''
    };
  },
  getValue: function getValue() {
    return this.state.value;
  },
  setValue: function setValue(value, text) {
    this.setState({
      value: value,
      text: text
    }, function () {
      this.props.onChange && this.props.onChange(value, this, null);
    });
  },
  __textRender: function __textRender() {
    return this.state.text || this.props.placeholder;
  },
  __onChange: function __onChange(data) {
    this.setValue(data.model, data.zn_title + " " + data.model);
    zn.modal.close();
  },
  __onClick: function __onClick() {
    zn.dialog({
      title: '选择商品',
      content: React.createElement(ProductSearcher, {
        onChange: this.__onChange
      })
    });
  },
  render: function render() {
    return React.createElement("div", {
      className: "zr-dropdown-selector",
      onClick: this.__onClick
    }, React.createElement("div", {
      className: "zr-dropdown-selector-text-view"
    }, React.createElement("span", {
      className: "text"
    }, this.__textRender()), React.createElement("i", {
      className: "trigger fa fa-angle-down"
    })));
  }
});