"use strict";

var React = require('react');

var BatchProductList = require('../component/BatchProductList');

module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      model: 'ZNPluginStockProductBatch'
    };
  },
  getInitialState: function getInitialState() {
    return {
      data: zn.store.post('/zn.plugin.admin/model/paging', {
        model: this.props.model,
        order: {
          zn_create_time: 'desc'
        }
      }),
      items: [{
        title: '批次号',
        name: 'batch_code',
        width: 150,
        filter: {
          type: 'Input',
          opts: ['like']
        }
      }, {
        title: '进入仓库',
        name: 'warehouse_id_convert',
        width: 140
      }, {
        title: '总数量',
        name: 'total_number',
        width: 120
      }, {
        title: '总金额(￥)',
        name: 'total_amount',
        width: 120
      }, {
        title: '创建人',
        name: 'zn_create_user_convert',
        width: 100
      }, {
        title: '创建时间',
        name: 'zn_create_time',
        width: 140
      }, {
        title: '说明',
        name: 'zn_note'
      }]
    };
  },
  __onCodeClick: function __onCodeClick(batchId, batchCode) {
    zn.dialog({
      title: '批次【' + batchCode + '】详情',
      content: React.createElement("div", {
        style: {
          overflow: 'auto',
          minHeight: 200
        }
      }, React.createElement(BatchProductList, {
        batchId: batchId
      }))
    });
  },
  __onTableColumnRender: function __onTableColumnRender(rowIndex, columnIndex, data, item, value) {
    var _this = this;

    switch (columnIndex) {
      case 0:
        return React.createElement("a", {
          href: "javascript:void(0)",
          onClick: function onClick() {
            return _this.__onCodeClick(data.id, data.batch_code);
          }
        }, value);
    }

    if (item.name.indexOf('total_') != -1) {
      return value.toFixed(2);
    }

    return value;
  },
  render: function render() {
    return React.createElement(zn.react.Page, {
      title: "\u5546\u54C1\u6279\u6B21\u7BA1\u7406"
    }, React.createElement(zn.react.PagerView, {
      view: "Table",
      enableFilter: true,
      showHeader: true,
      columnRender: this.__onTableColumnRender,
      data: this.state.data,
      items: this.state.items
    }));
  }
});