"use strict";

require('./ProductStock.less');

var React = require('react');

var ProductStock = require('../component/ProductStock.js');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      where: null,
      productType: null
    };
  },
  __onSearchKeyUp: function __onSearchKeyUp(event) {
    var _event = event.nativeEvent;

    if (_event.keyCode == 13) {
      var _value = _event.target.value;
      this.setState({
        where: _value ? {
          'model&like': _value
        } : null
      });
    }
  },
  __onSearchChange: function __onSearchChange(event) {
    var _event = event.nativeEvent;

    if (!_event.target.value) {
      this.setState({
        where: null
      });
    }
  },
  __rightView: function __rightView() {
    var _this = this;

    return React.createElement("div", {
      className: "right-view"
    }, React.createElement("div", {
      className: "zn-plugin-stock-searcher"
    }, React.createElement("input", {
      placeholder: "\u6839\u636E\u578B\u53F7\u67E5\u8BE2\u5546\u54C1",
      onChange: function onChange(event) {
        return _this.__onSearchChange(event);
      },
      onKeyUp: function onKeyUp(event) {
        return _this.__onSearchKeyUp(event);
      },
      className: "search-input",
      type: "search",
      name: "search"
    }), React.createElement("i", {
      className: "fa fa-search"
    })));
  },
  __onTypeChange: function __onTypeChange(value) {
    this.setState({
      productType: value.value
    });
  },
  __centerView: function __centerView() {
    return React.createElement(zn.react.Select, {
      onChange: this.__onTypeChange,
      value: 0,
      ref: function ref(el) {
        if (el) {
          el._reactInternalInstance._renderedComponent._hostNode.style.setProperty('background-color', '#FFF', 'important');
        }
      },
      placeholder: "\u6839\u636E\u7C7B\u578B\u67E5\u8BE2\u5546\u54C1",
      style: {
        padding: 5,
        height: 'auto'
      },
      data: zn.store.post("/zn.plugin.admin/model/select", {
        model: 'zn_plugin_stock_product_type',
        fields: "id as value, zn_title as text",
        where: {
          zn_tree_pid: 0
        }
      })
    });
  },
  __exportStock: function __exportStock() {
    var _data = {};

    if (this.props.request.search.warehouse) {
      _data.warehouseId = this.props.request.search.warehouse;
    }

    if (this.state.productType) {
      _data.typeId = this.state.productType;
    }

    zn.react.downloadURL(zn.http.fixURL('/zn.plugin.stock/stock/exportWarehouseStock?' + zn.querystring.stringify(_data)));
  },
  render: function render() {
    return React.createElement(zn.react.Page, {
      title: React.createElement("div", null, React.createElement("span", null, "\u5546\u54C1\u5E93\u5B58\u7BA1\u7406"), React.createElement("span", {
        onClick: this.__exportStock,
        className: "zr-tag fa fa-download danger"
      }, "\u4E00\u952E\u5BFC\u51FA\u5E93\u5B58")),
      headerCenter: this.__centerView(),
      rightView: this.__rightView()
    }, React.createElement(ProductStock, {
      warehouseId: this.props.request.search.warehouse,
      where: this.state.where,
      productType: this.state.productType
    }));
  }
});