var React = require('react');

module.exports = React.createClass({
	getDefaultProps: function (){
		return {
			eventType: 'click',
			model: 'ZNPluginStockProduct'
		}
	},
	getInitialState: function (){
		return {
			value: this.props.value||'',
			text: this.props.text||'',
			data: zn.store.post('/zn.plugin.admin/model/paging', {
				model: this.props.model,
				where: (this.props.productType ? { type_id: this.props.productType } : null)
			}),
			items: [
				//{ title: '序列号', name: 'serial_number', width: 110, filter: { type: 'Input', opts: ['like'] }  },
				{ title: '商品名称', name: 'zn_title', width: 160, filter: { type: 'Input', opts: ['like'] }  },
				{ title: '型号', name: 'model', width: 100, filter: { type: 'Input', opts: ['like'] }  },
				{ title: '规格', name: 'specification', width: 60 },
				{ title: '单位', name: 'unit', width: 60 },
				{ title: '净重(Kg)', name: 'net_weight', width: 100 },
				{ title: '毛重(Kg)', name: 'gross_weight', width: 100 },
				{ title: '包装尺寸(mm)', name: 'package_size', width: 100 },
				{ title: '容积(L)', name: 'volume', width: 100 },
				{ title: '单价(￥)', name: 'price', width: 100 },
				{ title: '最低价(￥)', name: 'min_price', width: 100 },
				{ title: '平均价(￥)', name: 'average_price', width: 100 },
				{ title: '最高价(￥)', name: 'max_price', width: 100 },
				{ title: '采购价(￥)', name: 'purchase_price', width: 100 },
				{ title: '销售价(￥)', name: 'sale_price', width: 100 },
				{ title: '物流单价(￥)', name: 'express_price', width: 100 }
			]
		}
	},
	getValue: function () {
		return this.state.value;
	},
	setValue: function (value, text) {
		this.setState({
			value: value,
			text: text
		}, function (){
			this.props.onChange && this.props.onChange(value, this, null);
		});
	},
	__textRender: function (){
		return this.state.text||this.props.placeholder;
	},
	__onSelectorChange: function (value){
		//this.setValue(value, item[rtlist.props.textKey]);
		zn.popover.close('DropdownSelector:selector.onchange');
	},
	__onTableColumnRender: function (rowIndex, columnIndex, data, item, value){
		if(item.title && item.title.indexOf('￥') != -1){
			value = (value).toFixed(2) + '￥';
		}
		return value;
	},
	__onPopoverClick: function (event){
		event.stopPropagation();
	},
	__onTableRowClick: function (event, obj, row){
		var _data = row.props.data;
		this.setValue(_data.id, _data.zn_title + "【" + _data.model + ' / ' + _data.specification + "】");
		zn.popover.close();
	},
	__popoverRender: function (){
		return <div onClick={this.__onPopoverClick}>
			<zn.react.PagerView
				view="Table"
				enableFilter={true}
				showHeader={true}
				columnRender={this.__onTableColumnRender}
				onTableRowClick={this.__onTableRowClick}
				data={this.state.data}
				dataFixed={false}
				items={this.state.items}/>
		</div>
	},
	render: function(){
		return (
			<zn.react.Dropdown {...this.props} popoverRender={this.__popoverRender} className="zr-dropdown-selector" style={{ width: '100%', maxHeight: 200 }} popoverWidth={480} >
				<div className="zr-dropdown-selector-text-view">
					<span className="text">{this.__textRender()}</span>
					<i className="trigger fa fa-angle-down" />
				</div>
			</zn.react.Dropdown>
		);
	}
});
