require('./ProductSelector.less');
var React = require('react');

var Product = React.createClass({
	getInitialState: function (){
		return {
			active: false
		};
	},
	render: function (){
		var item = this.props.data;
		return <li className="product">
			<div className="title">
				<span><i style={{ width: 16, textAlign: 'center', cursor: 'pointer' }} onClick={()=>this.setState({ active: !this.state.active })} className={"fa zr-padding-3 " + (this.state.active?'fa-angle-down':'fa-angle-right')} />{item.zn_title + " " + item.model}</span>
				<span onClick={()=>this.props.onSelect(item)} className="zr-tag zr-fr"><i className="fa fa-mouse-pointer zr-padding-3" />选择商品</span>
			</div>
			<div className="details" style={{display: (this.state.active?'block':'none')}}>
				<div className="group">
					<div>包装尺寸： {item.package_size}</div>
					<div>净重： {item.net_weight}/KG</div>
				</div>
				<div className="group">
					<div>商品价： ￥{item.price.toFixed(2)}</div>
					<div>平均价： ￥{item.average_price.toFixed(2)}</div>
					<div>采购价： ￥{item.purchase_price.toFixed(2)}</div>
					<div>销售价： ￥{item.sale_price.toFixed(2)}</div>
					<div>物流价： ￥{item.express_price.toFixed(2)}</div>
				</div>
			</div>
		</li>;
	}
});

var ProductSearcher = React.createClass({
	getInitialState: function (){
		return {
			data: [],
			sources: []
		}
	},
	componentDidMount: function (){
		this.__loadProducts();
	},
	__loadProducts: function (){
		zn.http.post('/zn.plugin.admin/model/select', {
			model: "ZNPluginStockProduct"
		}).then(function (data){
			if(data.status==200){
				this.setState({
					data: data.result,
					sources: data.result
				});
			}else {
				zn.notification.error(data.result);
			}
		}.bind(this), function (){
			zn.notification.error('请求失败');
		});
	},
	__onPopoverClick: function (event){
		event.stopPropagation();
	},
	searchAll: function (name){
        this.state.data = this.state.sources.slice(0).filter(function (item, index){
            if(item.model.toLocaleLowerCase().indexOf(name.toLocaleLowerCase())!=-1 || item.zn_title.toLocaleLowerCase().indexOf(name.toLocaleLowerCase())!=-1){
                return true;
            }
        });
        this.forceUpdate();
    },
	__onSearchKeyUp: function(event){
        var _event = event.nativeEvent;
        if(_event.keyCode==13){
            var _value = _event.target.value;
            this.searchAll(_value);
        }
    },
    __onSearchChange: function (event){
        var _event = event.nativeEvent;
        if(!_event.target.value){
            this.searchAll('');
        }
    },
	onProductSelect: function (item){
		this.props.onChange(item);
	},
	__renderData: function (){
		if(this.state.data && this.state.data.length){
			return <ul className="content products">
				{
					this.state.data.map(function (item){
						return <Product data={item} onSelect={()=>this.onProductSelect(item)} />;
					}.bind(this))
				}
			</ul>;
		}else {
			return <zn.react.DataLoader loader="timer" content="正在加载中..." />;
		}
	},
	render: function (){
		return (
			<div className="zn-plugin-stock-product-searcher" onClick={this.__onPopoverClick}>
				<div className="header">
					<span>[ {this.state.data.length}个 ] 商品</span>
					<div className="zn-plugin-stock-searcher">
						<input placeholder="根据型号查询" onChange={(event)=>this.__onSearchChange(event)} onKeyUp={(event)=>this.__onSearchKeyUp(event)} className="search-input" type="search" name="search" />
						<i className="fa fa-search" />
					</div>
				</div>
				{this.__renderData()}
			</div>
		);
	}
});

module.exports = React.createClass({
	getDefaultProps: function (){
		return {
			eventType: 'click'
		}
	},
	getInitialState: function (){
		return {
			value: this.props.value||'',
			text: this.props.text||'',
		}
	},
	getValue: function () {
		return this.state.value;
	},
	setValue: function (value, text) {
		this.setState({
			value: value,
			text: text
		}, function (){
			this.props.onChange && this.props.onChange(value, this, null);
		});
	},
	__textRender: function (){
		return this.state.text||this.props.placeholder;
	},
	__onChange: function (data){
		this.setValue(data.model, data.zn_title + " " + data.model);
		zn.modal.close();
	},
	__onClick: function (){
		zn.dialog({
			title: '选择商品',
			content: <ProductSearcher onChange={this.__onChange} />
		});
	},
	render: function(){
		return (
			<div className="zr-dropdown-selector" onClick={this.__onClick}>
				<div className="zr-dropdown-selector-text-view">
					<span className="text">{this.__textRender()}</span>
					<i className="trigger fa fa-angle-down" />
				</div>
			</div>
		);
	}
});
