require('./ProductStockLog.less');
var React = require('react');

module.exports = React.createClass({
	getInitialState: function (){
		return {
			data: zn.store.post('/zn.plugin.admin/table/paging', {
				table: 'zn_plugin_stock_product_stock_log',
				where: {
					product_model: this.props.product_model,
					warehouse_id: this.props.warehouse_id
				},
				order: {
					zn_create_time: 'desc'
				}
			}),
			items: [
				{ title: '流程ID', name: 'zn_plugin_workflow_instance_id', width: 120 },
				{ title: '类型', name: 'type', width: 160 },
				{ title: '数量', name: 'number', width: 100 },
				{ title: '操作时间', name: 'zn_create_time', width: 150 },
				{ title: '说明', name: 'comment' }
			],
		};
	},
	__onTableColumnRender: function (rowIndex, columnIndex, data, item, value){
		if(item.name == 'zn_plugin_workflow_instance_id'){
			if(value){
				return <a href={zn.react.session.relativeURL('/znpluginworkflow.wfinstance', { instanceId: value })}><i className="fa fa-eye" /> 查看流程 {value}</a>;
			}else {
				return <span style={{fontSize: 10}}>直接操作,无相关流程</span>;
			}
		}
		if(item.name == 'number'){
			if(+value>0){
				return <span style={{color: 'green'}}>
					{'+' + value}
				</span>;
			}else {
				return <span style={{color: 'red'}}>
					{value}
				</span>;
			}
		}
		return value;
	},
	render:function(){
		return (
			<zn.react.PagerView
				{...this.props}
				view="Table"
				showHeader={true}
				columnRender={this.__onTableColumnRender}
				data={this.state.data}
				dataFixed={true}
				items={this.state.items}/>
		);
	}
});
