var React = require('react');
var BatchProductList = require('../component/BatchProductList');
module.exports = React.createClass({
	getDefaultProps: function () {
		return {
			model: 'ZNPluginStockProductBatch'
		};
	},
	getInitialState: function () {
		return {
			data: zn.store.post('/zn.plugin.admin/model/paging', {
				model: this.props.model,
				order: {
					zn_create_time: 'desc'
				}
			}),
			items: [
				{ title: '批次号', name: 'batch_code', width: 150, filter: { type: 'Input', opts: ['like'] } },
				{ title: '进入仓库', name: 'warehouse_id_convert', width: 140 },
				{ title: '总数量', name: 'total_number', width: 120 },
				{ title: '总金额(￥)', name: 'total_amount', width: 120 },
				{ title: '创建人', name: 'zn_create_user_convert', width: 100 },
				{ title: '创建时间', name: 'zn_create_time', width: 140 },
				{ title: '说明', name: 'zn_note' }
			]
		}
	},
	__onCodeClick: function (batchId, batchCode){
		zn.dialog({
			title: '批次【'+batchCode+'】详情',
			content: <div style={{overflow: 'auto', minHeight: 200}}>
				<BatchProductList batchId={batchId} />
			</div>
		});
	},
	__onTableColumnRender: function (rowIndex, columnIndex, data, item, value){
		switch (columnIndex) {
			case 0:
				return <a href="javascript:void(0)" onClick={()=>this.__onCodeClick(data.id, data.batch_code)}>{value}</a>;
		}
		if(item.name.indexOf('total_')!=-1){
			return value.toFixed(2);
		}
		return value;
	},
	render:function(){
		return (
			<zn.react.Page title="商品批次管理">
				<zn.react.PagerView
					view="Table"
					enableFilter={true}
					showHeader={true}
					columnRender={this.__onTableColumnRender}
					data={this.state.data}
					items={this.state.items}/>
			</zn.react.Page>
		);
	}
});
