var React = require('react');
var ProductList = require('../component/ProductList.js');
module.exports = React.createClass({
	getDefaultProps: function () {
		return {
			model: 'zn_plugin_stock_product_type',
			pid: 0,
			title: '商品类型结构',
			fields: [
				{ title: '类型', type: 'Input', name: 'zn_title' },
				{ title: '说明', type: 'Textarea', name: 'zn_note' }
			]
		};
	},
	getInitialState: function () {
		return {
			refresh: false
		};
	},
	__onImportDataComplete: function (){
		zn.notification.success('导入数据成功');
		this.state.refresh = true;
		this.forceUpdate();
	},
	__rightRender: function (data){
		return <ProductList productType={data.value} />;
	},
	__emptyRender: function (data){
		return <ProductList refresh={this.state.refresh} />;
	},
	__itemContentRender: function (data, treeColumn, tree){
		return <span>{data.zn_title}</span>;
	},
	render:function(){
		return (
			<zn.plugin.admin.TreeModelView
				{...this.props}
				toolbarItems={[
					{
						icon: 'fa-upload',
						text: <zn.react.AjaxUploader
							action="/zn.plugin.stock/product/importProductType"
							onComplete={this.__onImportDataComplete}
							hiddens={{
								vars: {
									0: 'zn_title',
									1: 'model',
									2: 'specification',
									3: 'unit',
									4: 'net_weight',
									5: 'gross_weight',
									6: 'package_size',
									7: 'volume',
									8: 'price',
									9: 'min_price',
									10: 'max_price',
									11: 'purchase_price',
									12: 'sale_price',
									13: 'express_price'
								}
							}} >
							导入商品列表
						</zn.react.AjaxUploader>
					}
				]}
				emptyRender={this.__emptyRender}
				rightRender={this.__rightRender}
				itemContentRender={this.__itemContentRender} />
		);
	}
});
